#include "context.hxx"
#include "cpp_gateway_prototype.hxx"
#include "libsci_sundials.hxx"
extern "C"
{
#include "libsci_sundials.h"
}

#define MODULE_NAME L"libsci_sundials"

int libsci_sundials(wchar_t* _pwstFuncName)
{
    if(wcscmp(_pwstFuncName, L"cvode_solve") == 0){ symbol::Context::getInstance()->addFunction(types::Function::createFunction(L"cvode_solve", &sci_cvode_solve, MODULE_NAME)); }
    if(wcscmp(_pwstFuncName, L"cvode_extend") == 0){ symbol::Context::getInstance()->addFunction(types::Function::createFunction(L"cvode_extend", &sci_cvode_extend, MODULE_NAME)); }
    if(wcscmp(_pwstFuncName, L"%_odeSolution_clear") == 0){ symbol::Context::getInstance()->addFunction(types::Function::createFunction(L"%_odeSolution_clear", &sci_percent_odeSolution_clear, MODULE_NAME)); }
    if(wcscmp(_pwstFuncName, L"%_odeSolution_e") == 0){ symbol::Context::getInstance()->addFunction(types::Function::createFunction(L"%_odeSolution_e", &sci_percent_odeSolution_e, MODULE_NAME)); }

    return 1;
}
